﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Windows.Threading;
using Telerik.Windows.Controls;

namespace RadNumericUpDownWPF_1060538
{
    public class ViewModel : ViewModelBase
    {
        private double? durationFrom;
        private string currentText;

        public ViewModel()
        {
            this.PreviewKeyDownCommand = new DelegateCommand(OnPreviewKeyDownCommandExecuted);
        }

        public double? DurationFrom
        {
            get
            {
                return this.durationFrom;
            }
            set
            {
                if (this.durationFrom != value)
                {
                    this.durationFrom = value;
                    this.OnPropertyChanged(() => this.DurationFrom);
                }
            }
        }

        public string CurrentText
        {
            get
            {
                return this.currentText;
            }
            set
            {
                if (this.currentText != value)
                {
                    this.currentText = value;
                    this.OnPropertyChanged(()=>this.CurrentText);
                }
            }
        }

        public ICommand PreviewKeyDownCommand { get; set; }

        private void OnPreviewKeyDownCommandExecuted(object obj)
        {
            var keyArguments = obj as KeyEventArgs;

            if (keyArguments != null && keyArguments.Key == Key.Back)
            {
                Dispatcher.CurrentDispatcher.BeginInvoke(new Action(() =>
                {
                    if (string.IsNullOrEmpty(this.CurrentText))
                    {
                        this.DurationFrom = null;
                    }
                }));
            }
        }
    }
}
